package Mud;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

/**
 * Titre :        Mud
 * Description :
 * Copyright :    Copyright (c) 2001
 * Socit :
 * @author J. Ferber
 * @version 1.0
 */

public abstract class JeuCases extends JFrame implements ActionListener {
    int largeur=10;
	int hauteur=10;


    String serveurName = "localhost";
    public void setServeurName(String s){serveurName = s;}

    static final String OBSTACLE="Mud.Obstacle";
    static final String PERSONNAGE="Mud.Personnage";
    static final String TRESOR="Mud.Tresor";

	String currentType;

	Element[][] elements;
	JeuCasesDisplay display;

    Personnage personnageCourant=null;
    int currentColor=0;

    HashMap personnages = new HashMap();

    public void selectPersonnage(String id){
        Personnage p=(Personnage) personnages.get(id);
        if (p != null)
            personnageCourant = p;
    }


   JComboBox comboPerso;


    public JeuCases(String server) {
    	this.setServeurName(server);
	    addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

		elements = new Element[largeur][hauteur];
		getContentPane().setLayout(new BorderLayout());
		setSize(600,400);
		JButton b1=new JButton("Obstacle");
		JButton b2=new JButton("Personnage");
		JButton b3=new JButton("Tresor");
		JButton b4=new JButton("Dump");
		JPanel p1= new JPanel();
		p1.add(b1);
		p1.add(b2);
        p1.add(b3);
		p1.add(b4);
		getContentPane().add(p1,BorderLayout.NORTH);
		b1.addActionListener(this);
		b2.addActionListener(this);
		b3.addActionListener(this);
		b4.addActionListener(this);

		display = new JeuCasesDisplay(this);
		getContentPane().add(display,BorderLayout.CENTER);

        JButton ab1=new JButton("haut");
		JButton ab2=new JButton("bas");
		JButton ab3=new JButton("droite");
		JButton ab4=new JButton("gauche");
		JPanel p2= new JPanel();
        comboPerso=new JComboBox();
        p2.add(ab4);
        p2.add(ab1);
        p2.add(ab2);
        p2.add(ab3);
        p2.add(comboPerso);

		getContentPane().add(p2,BorderLayout.SOUTH);
		ab1.addActionListener(this);
		ab2.addActionListener(this);
		ab3.addActionListener(this);
		ab4.addActionListener(this);

        comboPerso.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JComboBox cb = (JComboBox)e.getSource();
                String persoName = (String)cb.getSelectedItem();
                selectPersonnage(persoName);
            }});

		show();
    }



	Element prendreElement(int c, int r){
		 return(elements[c][r]);
	}

	boolean valide(int c, int r){
		return((c >= 0) && (c < largeur) && (r >= 0) && (r < hauteur));
	}

	boolean occupe(int c, int r){
		return (!valide(c,r) || (elements[c][r] != null));
	}


	void mettreElement(Element p, int c, int r){
		 if (valide(c,r))
			elements[c][r]=p;
	}

	void supprimerElement(Element p, int c, int r){
		 if (occupe(c,r) && elements[c][r]==p)
			elements[c][r]=null;
	}



    void doClick(int x, int y){
          int c=0;
		  if (currentType!=null){
			Element p = (Element) createObject(currentType);
			if (p != null){
                if (p instanceof Personnage){
                    personnageCourant = (Personnage) p;
                    c = currentColor;
                    currentColor++;
                    String s = "pers"+c;
                    personnages.put(s,p);
                    comboPerso.addItem(s);
                    try {
                          // bind server name to registry
                          PersonnageDistant pdist = (PersonnageDistant) p;
                          UnicastRemoteObject.exportObject(pdist);
                          Naming.rebind("//"+serveurName+"/"+s+"/", pdist);
                          String[] strlst=Naming.list("//"+serveurName+"/");
                          System.out.print("listing names: ");
                          for(int i=0;i<strlst.length;i++)
                            System.out.print(strlst[i]+", ");
                          System.out.println();
                      }
                    catch (Exception e) {
                        System.out.println("Exception: " + e.getMessage());
                        e.printStackTrace();
                    }
                }
                p.installer(x,y,c,this,display);
            }
		 }
	}

	void dump(){
		 for(int j=0;j<hauteur;j++){
		   for(int i=0;i<largeur;i++){
		      if (elements[i][j] == null)
				 System.out.print("-");
			  else
				elements[i][j].dump();
		   }
		   System.out.println("");
		 }
	}

	public void actionPerformed(ActionEvent e){
		   String s = e.getActionCommand();
		    if (s.equals("Personnage")){
			  currentType = PERSONNAGE;
		   } else if (s.equals("Obstacle")){
			  currentType =OBSTACLE;
		   } else if (s.equals("Tresor")){
		      currentType = TRESOR;
		   } else if (s.equals("Dump"))
				 dump();
		    else if (s.equals("haut")){
				 if (personnageCourant != null)
                    personnageCourant.haut();
            }else if (s.equals("bas")){
				 if (personnageCourant != null)
                    personnageCourant.bas();
            } else if (s.equals("droite")){
				 if (personnageCourant != null)
                    personnageCourant.droite();
            } else if (s.equals("gauche")){
				 if (personnageCourant != null)
                    personnageCourant.gauche();
            }
	}

   Object createObject(String name){
          try{
            Class c = Class.forName(name);
            Object o = c.newInstance();
            return(o);
          }
          catch(ClassNotFoundException e){
            System.out.println("Classe inconnue : "+ e.getMessage());
          }
          catch(InstantiationException e){
            System.out.println("instantiation erreur : " + e.getMessage());
          }
          catch(IllegalAccessException e){
            System.out.println("Classe inconnue : " + e.getMessage());
          }
         return(null);
    }

}